



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Factor Combinations</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Factor Combinations</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 06:02:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Factor Combinations</h1>
<h1><strong>Problem</strong>:</h1>
<div>
<div>
<p>Numbers can be regarded as product of its factors. For example,</p>
<pre class="prettyprint linenums">8 = 2 x 2 x 2;<br />
  = 2 x 4.
</pre>
<p>Write a function that takes an integer&nbsp;<em>n</em>&nbsp;and return all possible combinations of its factors.</p>
<p>Note:</p>
<ol><li>Each combination's factors must be sorted ascending, for example: The factors of 2 and 6 is&nbsp;<code>[2, 6]</code>, not&nbsp;<code>[6, 2]</code>.</li>
<li>You may assume that&nbsp;<em>n</em>&nbsp;is always positive.</li>
<li>Factors should be greater than 1 and less than&nbsp;<em>n</em>.</li></ol>
<div>
<pre class="prettyprint linenums"> public class Solution {<br />
     public List&lt;List&lt;Integer&gt;&gt; getFactors(int n) {<br />
         List&lt;List&lt;Integer&gt;&gt; listAll = new ArrayList&lt;&gt;();<br />
         if (n &lt; ) return listAll;<br />
         List&lt;Integer&gt; list = factors(n);

         helper(n, , , list, listAll, new ArrayList&lt;Integer&gt;());<br />
         return listAll;<br />
     }

     public void helper(int n, long value, int index, List&lt;Integer&gt; list, List&lt;List&lt;Integer&gt;&gt; listAll, List&lt;Integer&gt; temp) {<br />
         if (index &gt;= list.size() || value &gt;= n) return;

         int curValue = list.get(index);<br />
         temp.add(curValue);<br />
         value *= curValue;

         if (n == value) {<br />
             listAll.add(new ArrayList&lt;Integer&gt;(temp));<br />
         }

         helper(n, value, index, list, listAll, temp);<br />
         value /= curValue;<br />
         temp.remove(temp.size() - );<br />
         helper(n, value, index + , list, listAll, temp);<br />
     }

     public List&lt;Integer&gt; factors(int n) {<br />
         List&lt;Integer&gt; list = new ArrayList&lt;&gt;();<br />
         for (int i = ; i &lt;= (n + ) / ; i++) {<br />
             if (n % i == ) {<br />
                 list.add(i);<br />
             }<br />
         }<br />
         return list;<br />
     }<br />
 }</pre>
</div>
<p>上面代码其实可以用另下面这种方法，原理一样。</p>
<div>
<pre class="prettyprint linenums"> public class Solution {<br />
   public List&lt;List&lt;Integer&gt;&gt; getFactors(int n) {<br />
       List&lt;List&lt;Integer&gt;&gt; result = new ArrayList&lt;&gt;();<br />
       List&lt;Integer&gt; list = new ArrayList&lt;&gt;();<br />
       helper(, , n, result, list);<br />
       return result;<br />
   }

   public void helper(int start, int product, int n, List&lt;List&lt;Integer&gt;&gt; result, List&lt;Integer&gt; curr) {<br />
       if (start &gt; n || product &gt; n) return;

       if (product == n) {<br />
           List&lt;Integer&gt; t = new ArrayList&lt;&gt;(curr);<br />
           result.add(t);<br />
       }

       for (int i = start; i &lt;= n / ; i++) {<br />
           if(i * product &gt; n) break;<br />
           if (n % i == ) {<br />
               curr.add(i);<br />
               helper(i, i * product, n, result, curr);<br />
               curr.remove(curr.size() - );<br />
           }<br />
       }<br />
   }<br />
 }</pre>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvyl1qx.html">php内核分析（一）－sapi&lowbar;module&lowbar;struct</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950em08.html">BZOJ1527 &colon; &lbrack;POI2005&rsqb;Pun-point</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4jn4eq.html">Visual Studio Code 调试 nodeJS</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zyz0x9.html">Java进击C&num;&mdash;&mdash;语法之面向对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwm0pl8.html">WCF初探-4：WCF消息交换模式之请求与答复模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm4olz9.html">使用Android Studio与ArcGIS Android SDK的开发环境部署和HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g1g59.html">iOS开发之&mdash;&mdash;巧用反射机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wdoxq.html">Android中GridView的使用&mdash;&mdash;使用自带的SimpleAdapter&lpar;简单适配器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11p2oq.html">MiniGUI文档参考手册 基于v1&period;6&period;10文本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4vx69.html">VMware Workstation14 安装Ubuntu18&period;04</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0e61q.html">pwn易忘操作原理笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wo61nq.html">Oracle启用和禁用触发器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1ly59.html">事件冒泡&lpar;event bubbling&rpar;与事件捕捉&lpar;event capturing&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250dkxq.html">Windows PowerShell 入門（1）－基本操作編</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgdrk8.html">如何某个js文件中的 console</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25433vq.html">正则表达式的lastIndex属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjnl4o8.html">转：Xcode打印堆栈信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlnx6y9.html">Html&period;Partial（）传值的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql132v19.html">mysql 搜索字段不包含数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zv34gv9.html">dubbox消费者启动成功，却无法连接注册中心</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q2ndklq.html">yii2 小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r3z179.html">获取SQLSERVER所有库 所有表 所有列  所有字段信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jr0gwq.html">【struts2】Result和ResultType</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8owk0p9.html">MYSql存储过程的作用及语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/495vx26q.html">iOS数据库学习&lpar;1&rpar;-安装Navicat</a>
			</li>
						<li><a href="https://www.batexi.com/a/495v0eeq.html">如何在html中做圆角矩形和 只有右边的&amp;quot&semi;分隔线&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2n5r3q.html">Java基础相关总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96k303q.html">淘宝首页源码藏美女彩蛋&lpar;上&rpar;（UED新作2013egg）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvoegj8.html">Nginx 502 bad gateway问题的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7w7rg9.html">C&num;深入浅出 修饰符（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
